// MQL4&5-code

//   MT4  MT5  .
// https://www.mql5.com/ru/code/16006

//  mqh-   #include      MQL5 (MT5-Hedge)   ,   MQL4.
// ..    ()   MQL4.      
// MQL5- .  ,  MQL5-    .
//       .   !

//   MQL4 -> MQL5      .
//        (     MT4  #property strict):

// #include <MT4Orders.mqh> //   #include <Expert/Expert.mqh>,    

//   (  )   MQL5-,    MT5-   MT4-,    .

//      ,         " "
//  ,  ,   ..

//      .

//      ,  MQL4-    MT5  ,  .

//   :
//   CloseBy- -     . ,  ,  .
//    TP  SL   -    (build 1470) MQL5    .
//    DEAL_ENTRY_INOUT  DEAL_ENTRY_OUT_BY .

// :
//    MT4 OrderSelect   SELECT_BY_TICKET     MODE_TRADES/MODE_HISTORY,
//   .. "     ".
//    MT5    ,
//    OrderSelect   SELECT_BY_TICKET       :
//     MODE_TRADES:    >   >  >  
//     MODE_HISTORY:  >   >   >  
//
// , OrderSelect   SELECT_BY_TICKET  MT5    ( )    ,    MT4.
//
//   OrdersTotal()   ,      MT5-.

//  :
// 03.08.2016:
//    -      -.
// 29.09.2016:
//   Add:     (SYMBOL_TRADE_EXECUTION_EXCHANGE). ,   - Netto( Hedge)-mode.
//   Add:   "  #include <Trade/Trade.mqh>,    "
//          "  #include <Expert/Expert.mqh>,    ".
//   Fix: OrderSend -   ,   .
// 13.11.2016:
//   Add:   OrderSend, OrderModify, OrderClose, OrderDelete    (-  ) -   MT4.
//              MT4ORDERS::OrderSend_MaxPause  .     MT5 ~1 .
//        -      . MT4ORDERS::OrderSend_MaxPause = 0 -  .
//   Add:   SlipPage (OrderSend, OrderClose)    -   Instant-,
//                    - ENUM_ORDER_TYPE_FILLING:
//        ORDER_FILLING_FOK, ORDER_FILLING_IOC  ORDER_FILLING_RETURN.
//                       .
//        :
//          OrderSend(Symb, Type, Lots, Price, ORDER_FILLING_FOK, SL, TP) -       ORDER_FILLING_FOK
//          OrderSend(Symb, Type, Lots, Price, ORDER_FILLING_IOC, SL, TP) -       ORDER_FILLING_IOC
//          OrderClose(Ticket, Lots, Price, ORDER_FILLING_RETURN) -   -    ORDER_FILLING_RETURN
//   Add: OrdersHistoryTotal()  OrderSelect(Pos, SELECT_BY_POS, MODE_HISTORY)  -   .
//             .

#ifdef __MQL5__
#ifndef __MT4ORDERS__

#define __MT4ORDERS__

#define RESERVE_SIZE 1000
#define DAY (24 * 3600)
#define HISTORY_PAUSE (MT4HISTORY::IsTester ? 0 : 5)

class MT4HISTORY
{
private:
  static const bool IsTester;

  long Tickets[];
  uint Amount;

  datetime LastTime;

  int LastTotalDeals;
  int LastTotalOrders;

  datetime LastInitTime;

#define GETNEXTPOS_FUNCTION(NAME)                                    \
  static int GetNextPosMT4##NAME( int iPos )                         \
  {                                                                  \
    const int Total = ::History##NAME##sTotal();                     \
                                                                     \
    while (iPos < Total)                                             \
    {                                                                \
      if (MT4HISTORY::IsMT4##NAME(::History##NAME##GetTicket(iPos))) \
        break;                                                       \
                                                                     \
      iPos++;                                                        \
    }                                                                \
                                                                     \
    return(iPos);                                                    \
  }

  GETNEXTPOS_FUNCTION(Order)
  GETNEXTPOS_FUNCTION(Deal)

#undef GETNEXTPOS_FUNCTION

  bool RefreshHistory( void )
  {
    bool Res = false;

    const datetime LastTimeCurrent = ::TimeCurrent();

    if ((!MT4HISTORY::IsTester) && (LastTimeCurrent >= this.LastInitTime + DAY))
    {
      this.LastTime = 0;

      this.LastTotalOrders = 0;
      this.LastTotalDeals = 0;

      this.Amount = 0;

      ::ArrayResize(this.Tickets, this.Amount, RESERVE_SIZE);

      this.LastInitTime = LastTimeCurrent;
    }

    if (::HistorySelect(this.LastTime, ::MathMax(LastTimeCurrent, this.LastTime) + DAY)) //  
    {
      const int TotalOrders = ::HistoryOrdersTotal();
      const int TotalDeals = ::HistoryDealsTotal();

      Res = ((TotalOrders != this.LastTotalOrders) || (TotalDeals != this.LastTotalDeals));

      if (Res)
      {
        int iOrder = MT4HISTORY::GetNextPosMT4Order(this.LastTotalOrders);
        int iDeal = MT4HISTORY::GetNextPosMT4Deal(this.LastTotalDeals);

        long TimeOrder = (iOrder < TotalOrders) ? ::HistoryOrderGetInteger(::HistoryOrderGetTicket(iOrder), ORDER_TIME_DONE/*_MSC*/) : LONG_MAX; // ORDER_TIME_DONE_MSC     (build 1470)
        long TimeDeal = (iDeal < TotalDeals) ? ::HistoryDealGetInteger(::HistoryDealGetTicket(iDeal), DEAL_TIME/*_MSC*/) : LONG_MAX;

        while ((iDeal < TotalDeals) || (iOrder < TotalOrders))
          if (TimeOrder < TimeDeal)
          {
            this.Amount = ::ArrayResize(this.Tickets, this.Amount + 1, RESERVE_SIZE);

            this.Tickets[this.Amount - 1] = -(long)::HistoryOrderGetTicket(iOrder);

            iOrder = MT4HISTORY::GetNextPosMT4Order(iOrder + 1);

            TimeOrder = (iOrder < TotalOrders) ? ::HistoryOrderGetInteger(::HistoryOrderGetTicket(iOrder), ORDER_TIME_DONE/*_MSC*/) : LONG_MAX; // ORDER_TIME_DONE_MSC     (build 1470)
          }
          else
          {
            this.Amount = ::ArrayResize(this.Tickets, this.Amount + 1, RESERVE_SIZE);

            this.Tickets[this.Amount - 1] = (long)::HistoryDealGetTicket(iDeal);

            iDeal = MT4HISTORY::GetNextPosMT4Deal(iDeal + 1);

            TimeDeal = (iDeal < TotalDeals) ? ::HistoryDealGetInteger(::HistoryDealGetTicket(iDeal), DEAL_TIME/*_MSC*/) : LONG_MAX;
          }

        TimeOrder = (TotalOrders > 0) ? ::HistoryOrderGetInteger(::HistoryOrderGetTicket(TotalOrders - 1), ORDER_TIME_DONE/*_MSC*/) : 0;
        TimeDeal = (TotalDeals > 0) ? ::HistoryDealGetInteger(::HistoryDealGetTicket(TotalDeals - 1), DEAL_TIME/*_MSC*/) : 0;

        const long MaxTime = ::MathMax(TimeOrder, TimeDeal);

        this.LastTotalOrders = 0;
        this.LastTotalDeals = 0;

        if (LastTimeCurrent - HISTORY_PAUSE > MaxTime)
          this.LastTime = LastTimeCurrent - HISTORY_PAUSE;
        else
        {
          this.LastTime = (datetime)MaxTime;

          if (TimeOrder == MaxTime)
            for (int i = TotalOrders - 1; i >= 0; i--)
            {
              if (TimeOrder > ::HistoryOrderGetInteger(::HistoryOrderGetTicket(i), ORDER_TIME_DONE/*_MSC*/))
                break;

              this.LastTotalOrders++;
            }

          if (TimeDeal == MaxTime)
            for (int i = TotalDeals - 1; i >= 0; i--)
            {
              if (TimeDeal != ::HistoryDealGetInteger(::HistoryDealGetTicket(TotalDeals - 1), DEAL_TIME/*_MSC*/))
                break;

              this.LastTotalDeals++;
            }
        }
      }
      else if (LastTimeCurrent - HISTORY_PAUSE > this.LastTime)
      {
        this.LastTime = LastTimeCurrent - HISTORY_PAUSE;

        this.LastTotalOrders = 0;
        this.LastTotalDeals = 0;
      }
    }

    return(Res);
  }

public:
  static bool IsMT4Deal( const ulong Ticket )
  {
    const ENUM_DEAL_TYPE Type = (ENUM_DEAL_TYPE)::HistoryDealGetInteger(Ticket, DEAL_TYPE);

    return(((Type != DEAL_TYPE_BUY) && (Type != DEAL_TYPE_SELL)) || ((ENUM_DEAL_ENTRY)::HistoryDealGetInteger(Ticket, DEAL_ENTRY) == DEAL_ENTRY_OUT));
  }

  static bool IsMT4Order( const ulong Ticket )
  {
    return((::HistoryOrderGetDouble(Ticket, ORDER_VOLUME_CURRENT) > 0) || (::HistoryOrderGetInteger(Ticket, ORDER_POSITION_ID) == 0));
  }

  MT4HISTORY( void ) : Amount(0), LastTime(0), LastTotalDeals(0), LastTotalOrders(0), LastInitTime(0)
  {
    ::ArrayResize(this.Tickets, this.Amount, RESERVE_SIZE);

    this.RefreshHistory();
  }

  int GetAmount( void )
  {
    this.RefreshHistory();

    return((int)this.Amount);
  }

  long operator []( const uint Pos )
  {
    long Res = 0;

    if (Pos >= this.Amount)
    {
      this.RefreshHistory();

      if (Pos < this.Amount)
        Res = this.Tickets[Pos];
    }
    else
      Res = this.Tickets[Pos];

    return(Res);
  }
};

static const bool MT4HISTORY::IsTester = (::MQLInfoInteger(MQL_TESTER) || ::MQLInfoInteger(MQL_OPTIMIZATION) ||
                                          ::MQLInfoInteger(MQL_VISUAL_MODE) || ::MQLInfoInteger(MQL_FRAME_MODE));

#undef HISTORY_PAUSE
#undef DAY
#undef RESERVE_SIZE

struct MT4_ORDER
{
  int Ticket;
  int Type;

  double Lots;

  string Symbol;
  string Comment;

  double OpenPrice;
  datetime OpenTime;

  double StopLoss;
  double TakeProfit;

  double ClosePrice;
  datetime CloseTime;

  datetime Expiration;

  int MagicNumber;

  double Profit;

  double Commission;
  double Swap;

  string ToString( void ) const
  {
    static const string Types[] = {"buy", "sell", "buy limit", "sell limit", "buy stop", "sell stop", "balance"};
    const int digits = (int)::SymbolInfoInteger(this.Symbol, SYMBOL_DIGITS);

    return("#" + (string)this.Ticket + " " +
           (string)this.OpenTime + " " +
           ((this.Type < ::ArraySize(Types)) ? Types[this.Type] : "unknown") + " " +
           ::DoubleToString(this.Lots, 2) + " " +
           this.Symbol + " " +
           ::DoubleToString(this.OpenPrice, digits) + " " +
           ::DoubleToString(this.StopLoss, digits) + " " +
           ::DoubleToString(this.TakeProfit, digits) + " " +
           ((this.CloseTime > 0) ? ((string)this.CloseTime + " ") : "") +
           ::DoubleToString(this.ClosePrice, digits) + " " +
           ::DoubleToString(this.Commission, 2) + " " +
           ::DoubleToString(this.Swap, 2) + " " +
           ::DoubleToString(this.Profit, 2) + " " +
           ((this.Comment == "") ? "" : (this.Comment + " ")) +
           (string)this.MagicNumber +
           (((this.Expiration > 0) ? (" expiration " + (string)this.Expiration): "")));
  }
};

#define OP_BUY ORDER_TYPE_BUY
#define OP_SELL ORDER_TYPE_SELL
#define OP_BUYLIMIT ORDER_TYPE_BUY_LIMIT
#define OP_SELLLIMIT ORDER_TYPE_SELL_LIMIT
#define OP_BUYSTOP ORDER_TYPE_BUY_STOP
#define OP_SELLSTOP ORDER_TYPE_SELL_STOP
#define OP_BALANCE 6

#define SELECT_BY_POS 0
#define SELECT_BY_TICKET 1

#define MODE_TRADES 0
#define MODE_HISTORY 1

class MT4ORDERS
{
private:
  static MT4_ORDER Order;
  static MT4HISTORY History;

  static const bool IsTester;

  static ulong GetPositionDealIn( const ulong PositionIdentifier = 0 )
  {
    ulong Ticket = 0;

    if ((PositionIdentifier == 0) ? ::HistorySelectByPosition(::PositionGetInteger(POSITION_IDENTIFIER)) : ::HistorySelectByPosition(PositionIdentifier))
    {
      const int Total = ::HistoryDealsTotal();

      for (int i = 0; i < Total; i++)
      {
        const ulong TicketDeal = ::HistoryDealGetTicket(i);

        if (TicketDeal > 0)
          if ((ENUM_DEAL_ENTRY)::HistoryDealGetInteger(TicketDeal, DEAL_ENTRY) == DEAL_ENTRY_IN)
          {
            Ticket = TicketDeal;

            break;
          }
      }
    }

    return(Ticket);
  }

  static double GetPositionCommission( void )
  {
    double Commission = ::PositionGetDouble(POSITION_COMMISSION);

    //  ,  POSITION_COMMISSION  
    if (Commission == 0)
    {
      const ulong Ticket = MT4ORDERS::GetPositionDealIn();

      if (Ticket > 0)
      {
        const double LotsIn = ::HistoryDealGetDouble(Ticket, DEAL_VOLUME);

        if (LotsIn > 0)
          Commission = ::HistoryDealGetDouble(Ticket, DEAL_COMMISSION) * ::PositionGetDouble(POSITION_VOLUME) / LotsIn;
      }
    }

  return(Commission);
}

  static string GetPositionComment( void )
  {
    string comment = ::PositionGetString(POSITION_COMMENT);

    if (comment == "")
    {
      const ulong Ticket = MT4ORDERS::GetPositionDealIn();

      if (Ticket > 0)
        comment = ::HistoryDealGetString(Ticket, DEAL_COMMENT);
    }

    return(comment);
  }

  static void GetPositionData( void )
  {
    MT4ORDERS::Order.Ticket = (int)::PositionGetInteger(POSITION_TICKET);
    MT4ORDERS::Order.Type = (int)::PositionGetInteger(POSITION_TYPE);

    MT4ORDERS::Order.Lots = ::PositionGetDouble(POSITION_VOLUME);

    MT4ORDERS::Order.Symbol = ::PositionGetString(POSITION_SYMBOL);
    MT4ORDERS::Order.Comment = MT4ORDERS::GetPositionComment();

    MT4ORDERS::Order.OpenPrice = ::PositionGetDouble(POSITION_PRICE_OPEN);
    MT4ORDERS::Order.OpenTime = (datetime)::PositionGetInteger(POSITION_TIME);

    MT4ORDERS::Order.StopLoss = ::PositionGetDouble(POSITION_SL);
    MT4ORDERS::Order.TakeProfit = ::PositionGetDouble(POSITION_TP);

    MT4ORDERS::Order.ClosePrice = ::PositionGetDouble(POSITION_PRICE_CURRENT);
    MT4ORDERS::Order.CloseTime = 0;

    MT4ORDERS::Order.Expiration = 0;

    MT4ORDERS::Order.MagicNumber = (int)::PositionGetInteger(POSITION_MAGIC);

    MT4ORDERS::Order.Profit = ::PositionGetDouble(POSITION_PROFIT);

    MT4ORDERS::Order.Commission = MT4ORDERS::GetPositionCommission();
    MT4ORDERS::Order.Swap = ::PositionGetDouble(POSITION_SWAP);

    return;
  }

  static void GetOrderData( void )
  {
    MT4ORDERS::Order.Ticket = (int)::OrderGetInteger(ORDER_TICKET);
    MT4ORDERS::Order.Type = (int)::OrderGetInteger(ORDER_TYPE);

    MT4ORDERS::Order.Lots = ::OrderGetDouble(ORDER_VOLUME_CURRENT);

    MT4ORDERS::Order.Symbol = ::OrderGetString(ORDER_SYMBOL);
    MT4ORDERS::Order.Comment = ::OrderGetString(ORDER_COMMENT);

    MT4ORDERS::Order.OpenPrice = ::OrderGetDouble(ORDER_PRICE_OPEN);
    MT4ORDERS::Order.OpenTime = (datetime)::OrderGetInteger(ORDER_TIME_SETUP);

    MT4ORDERS::Order.StopLoss = ::OrderGetDouble(ORDER_SL);
    MT4ORDERS::Order.TakeProfit = ::OrderGetDouble(ORDER_TP);

    MT4ORDERS::Order.ClosePrice = ::OrderGetDouble(ORDER_PRICE_CURRENT);
    MT4ORDERS::Order.CloseTime = (datetime)::OrderGetInteger(ORDER_TIME_DONE);

    MT4ORDERS::Order.Expiration = (datetime)::OrderGetInteger(ORDER_TIME_EXPIRATION);

    MT4ORDERS::Order.MagicNumber = (int)::OrderGetInteger(ORDER_MAGIC);

    MT4ORDERS::Order.Profit = 0;

    MT4ORDERS::Order.Commission = 0;
    MT4ORDERS::Order.Swap = 0;

    return;
  }

  static void GetHistoryOrderData( const ulong Ticket )
  {
    MT4ORDERS::Order.Ticket = (int)::HistoryOrderGetInteger(Ticket, ORDER_TICKET);
    MT4ORDERS::Order.Type = (int)::HistoryOrderGetInteger(Ticket, ORDER_TYPE);

    MT4ORDERS::Order.Lots = ::HistoryOrderGetDouble(Ticket, ORDER_VOLUME_CURRENT);

    if (MT4ORDERS::Order.Lots == 0)
      MT4ORDERS::Order.Lots = ::HistoryOrderGetDouble(Ticket, ORDER_VOLUME_INITIAL);

    MT4ORDERS::Order.Symbol = ::HistoryOrderGetString(Ticket, ORDER_SYMBOL);
    MT4ORDERS::Order.Comment = ::HistoryOrderGetString(Ticket, ORDER_COMMENT);

    MT4ORDERS::Order.OpenPrice = ::HistoryOrderGetDouble(Ticket, ORDER_PRICE_OPEN);
    MT4ORDERS::Order.OpenTime = (datetime)::HistoryOrderGetInteger(Ticket, ORDER_TIME_SETUP);

    MT4ORDERS::Order.StopLoss = ::HistoryOrderGetDouble(Ticket, ORDER_SL);
    MT4ORDERS::Order.TakeProfit = ::HistoryOrderGetDouble(Ticket, ORDER_TP);

    MT4ORDERS::Order.ClosePrice = 0; // ::HistoryOrderGetDouble(Ticket, ORDER_PRICE_CURRENT);
    MT4ORDERS::Order.CloseTime = (datetime)::HistoryOrderGetInteger(Ticket, ORDER_TIME_DONE);

    MT4ORDERS::Order.Expiration = (datetime)::HistoryOrderGetInteger(Ticket, ORDER_TIME_EXPIRATION);

    MT4ORDERS::Order.MagicNumber = (int)::HistoryOrderGetInteger(Ticket, ORDER_MAGIC);

    MT4ORDERS::Order.Profit = 0;

    MT4ORDERS::Order.Commission = 0;
    MT4ORDERS::Order.Swap = 0;

    return;
  }

  static void GetHistoryPositionData( const ulong Ticket )
  {
    MT4ORDERS::Order.Ticket = (int)::HistoryDealGetInteger(Ticket, DEAL_TICKET);
    MT4ORDERS::Order.Type = (int)::HistoryDealGetInteger(Ticket, DEAL_TYPE);

    if ((MT4ORDERS::Order.Type > OP_SELL))
      MT4ORDERS::Order.Type += (OP_BALANCE - OP_SELL - 1);
    else
      MT4ORDERS::Order.Type = 1 - MT4ORDERS::Order.Type;

    MT4ORDERS::Order.Lots = ::HistoryDealGetDouble(Ticket, DEAL_VOLUME);

    MT4ORDERS::Order.Symbol = ::HistoryDealGetString(Ticket, DEAL_SYMBOL);
    MT4ORDERS::Order.Comment = ::HistoryDealGetString(Ticket, DEAL_COMMENT);

    MT4ORDERS::Order.OpenPrice = ::HistoryDealGetDouble(Ticket, DEAL_PRICE);
    MT4ORDERS::Order.OpenTime = (datetime)::HistoryDealGetInteger(Ticket, DEAL_TIME);

    //  StopLoss  TakeProfit   - build 1368
    MT4ORDERS::Order.StopLoss = 0; // ::HistoryDealGetDouble(Ticket, DEAL_SL);
    MT4ORDERS::Order.TakeProfit = 0; // ::HistoryDealGetDouble(Ticket, DEAL_TP);

    MT4ORDERS::Order.ClosePrice = ::HistoryDealGetDouble(Ticket, DEAL_PRICE);
    MT4ORDERS::Order.CloseTime = (datetime)::HistoryDealGetInteger(Ticket, DEAL_TIME);;

    MT4ORDERS::Order.Expiration = 0;

    MT4ORDERS::Order.MagicNumber = (int)::HistoryDealGetInteger(Ticket, DEAL_MAGIC);

    MT4ORDERS::Order.Profit = ::HistoryDealGetDouble(Ticket, DEAL_PROFIT);

    MT4ORDERS::Order.Commission = ::HistoryDealGetDouble(Ticket, DEAL_COMMISSION);
    MT4ORDERS::Order.Swap = ::HistoryDealGetDouble(Ticket, DEAL_SWAP);
/*
    const ulong OrderTicket = ::HistoryDealGetInteger(Ticket, DEAL_ORDER);

    if (::HistoryOrderSelect(OrderTicket))
    {
      //  -  : . OrderClose.
      MT4ORDERS::Order.StopLoss = ::HistoryOrderGetDouble(OrderTicket, ORDER_TP);
      MT4ORDERS::Order.TakeProfit = ::HistoryOrderGetDouble(OrderTicket, ORDER_SL);
    }
*/
    const ulong OpenTicket = MT4ORDERS::GetPositionDealIn(::HistoryDealGetInteger(Ticket, DEAL_POSITION_ID));

    if (OpenTicket > 0)
    {
      MT4ORDERS::Order.OpenPrice = ::HistoryDealGetDouble(OpenTicket, DEAL_PRICE);
      MT4ORDERS::Order.OpenTime = (datetime)::HistoryDealGetInteger(OpenTicket, DEAL_TIME);

      const double OpenLots = ::HistoryDealGetDouble(OpenTicket, DEAL_VOLUME);

      if (OpenLots > 0)
        MT4ORDERS::Order.Commission += ::HistoryDealGetDouble(OpenTicket, DEAL_COMMISSION) * MT4ORDERS::Order.Lots / OpenLots;

      if (MT4ORDERS::Order.MagicNumber == 0)
        MT4ORDERS::Order.MagicNumber = (int)::HistoryDealGetInteger(OpenTicket, DEAL_MAGIC);

      if (MT4ORDERS::Order.Comment == "")
        MT4ORDERS::Order.Comment = ::HistoryDealGetString(OpenTicket, DEAL_COMMENT);
    }

    return;
  }

  static bool Waiting( const bool FlagInit = false )
  {
    static ulong StartTime = 0;

    if (FlagInit)
      StartTime = ::GetMicrosecondCount();

    const bool Res = (::GetMicrosecondCount() - StartTime < MT4ORDERS::OrderSend_MaxPause);

    if (Res)
      ::Sleep(0);

    return(Res);
  }

  static bool EqualPrices( const double Price1, const double Price2, const int digits)
  {
    return(::NormalizeDouble(Price1 - Price2, digits) == 0);
  }

#define WHILE(A) while (!(Res = (A)) && MT4ORDERS::Waiting())

  static bool OrderSend( const MqlTradeRequest &Request, MqlTradeResult &Result )
  {
    bool Res = ::OrderSend(Request, Result);

    if (Res && !MT4ORDERS::IsTester && (Result.retcode < TRADE_RETCODE_ERROR) && (MT4ORDERS::OrderSend_MaxPause > 0))
    {
      Res = (Result.retcode == TRADE_RETCODE_DONE);
      MT4ORDERS::Waiting(true);

      if (Request.action == TRADE_ACTION_DEAL)
      {
        WHILE(::HistoryOrderSelect(Result.order))
          ;

        Res = Res && (((ENUM_ORDER_STATE)::HistoryOrderGetInteger(Result.order, ORDER_STATE) == ORDER_STATE_FILLED) ||
                      ((ENUM_ORDER_STATE)::HistoryOrderGetInteger(Result.order, ORDER_STATE) == ORDER_STATE_PARTIAL));

        if (Res)
          WHILE(::HistoryDealSelect(Result.deal))
            ;
      }
      else if (Request.action == TRADE_ACTION_PENDING)
      {
        if (Res)
          WHILE(::OrderSelect(Result.order))
            ;
        else
        {
          WHILE(::HistoryOrderSelect(Result.order))
            ;

          Res = false;
        }
      }
      else if (Request.action == TRADE_ACTION_SLTP)
      {
        if (Res)
        {
          bool EqualSL = false;
          bool EqualTP = false;

          const int digits = (int)::SymbolInfoInteger(Request.symbol, SYMBOL_DIGITS);

          if ((Request.position == 0) ? ::PositionSelect(Request.symbol) : ::PositionSelectByTicket(Request.position))
          {
            EqualSL = MT4ORDERS::EqualPrices(::PositionGetDouble(POSITION_SL), Request.sl, digits);
            EqualTP = MT4ORDERS::EqualPrices(::PositionGetDouble(POSITION_TP), Request.tp, digits);
          }

          WHILE((EqualSL && EqualTP))
            if ((Request.position == 0) ? ::PositionSelect(Request.symbol) : ::PositionSelectByTicket(Request.position))
            {
              EqualSL = MT4ORDERS::EqualPrices(::PositionGetDouble(POSITION_SL), Request.sl, digits);
              EqualTP = MT4ORDERS::EqualPrices(::PositionGetDouble(POSITION_TP), Request.tp, digits);
            }
        }
      }
      else if (Request.action == TRADE_ACTION_MODIFY)
      {
        if (Res)
        {
          bool EqualSL = false;
          bool EqualTP = false;

          const int digits = (int)::SymbolInfoInteger(Request.symbol, SYMBOL_DIGITS);

          if (::OrderSelect(Result.order))
          {
            EqualSL = MT4ORDERS::EqualPrices(::OrderGetDouble(ORDER_SL), Request.sl, digits);
            EqualTP = MT4ORDERS::EqualPrices(::OrderGetDouble(ORDER_TP), Request.tp, digits);
          }

          WHILE((EqualSL && EqualTP))
            if (::OrderSelect(Result.order))
            {
              EqualSL = MT4ORDERS::EqualPrices(::OrderGetDouble(ORDER_SL), Request.sl, digits);
              EqualTP = MT4ORDERS::EqualPrices(::OrderGetDouble(ORDER_TP), Request.tp, digits);
            }
        }
      }
      else if (Request.action == TRADE_ACTION_REMOVE)
        if (Res)
          WHILE(::HistoryOrderSelect(Result.order))
            ;
    }

    return(Res);
  }

#undef WHILE

  static bool NewOrderSend( const MqlTradeRequest &Request )
  {
    MqlTradeResult Result;

    return(MT4ORDERS::OrderSend(Request, Result) ? Result.retcode < TRADE_RETCODE_ERROR : false);
  }

  static bool ModifyPosition( const int Ticket, MqlTradeRequest &Request )
  {
    const bool Res = ::PositionSelectByTicket(Ticket);

    if (Res)
    {
      Request.action = TRADE_ACTION_SLTP;

      Request.position = Ticket;
      Request.symbol = ::PositionGetString(POSITION_SYMBOL); //     !
    }

    return(Res);
  }

  static ENUM_ORDER_TYPE_FILLING GetFilling( const string Symb, const uint Type = ORDER_FILLING_FOK )
  {
    const ENUM_SYMBOL_TRADE_EXECUTION ExeMode = (ENUM_SYMBOL_TRADE_EXECUTION)::SymbolInfoInteger(Symb, SYMBOL_TRADE_EXEMODE);
    const int FillingMode = (int)::SymbolInfoInteger(Symb, SYMBOL_FILLING_MODE);

    return((FillingMode == 0 || (Type >= ORDER_FILLING_RETURN) || ((FillingMode & (Type + 1)) != Type + 1)) ?
           (((ExeMode == SYMBOL_TRADE_EXECUTION_EXCHANGE) || (ExeMode == SYMBOL_TRADE_EXECUTION_INSTANT)) ?
             ORDER_FILLING_RETURN : ((FillingMode == SYMBOL_FILLING_IOC) ? ORDER_FILLING_IOC : ORDER_FILLING_FOK)) :
            (ENUM_ORDER_TYPE_FILLING)Type);
  }

  static bool ModifyOrder( const int Ticket, const double Price, const datetime Expiration, MqlTradeRequest &Request )
  {
    const bool Res = ::OrderSelect(Ticket);

    if (Res)
    {
      Request.action = TRADE_ACTION_MODIFY;
      Request.order = Ticket;

      Request.price = Price;

      Request.symbol = ::OrderGetString(ORDER_SYMBOL);

      // https://www.mql5.com/ru/forum/160790/page2#comment_3831285
//      Request.type_filling = (ENUM_ORDER_TYPE_FILLING)::OrderGetInteger(ORDER_TYPE_FILLING);
      Request.type_filling = MT4ORDERS::GetFilling(Request.symbol);

      if (Expiration > 0)
      {
        Request.type_time = ORDER_TIME_SPECIFIED;
        Request.expiration = Expiration;
      }
    }

    return(Res);
  }

  static bool SelectByPosHistory( const int Index )
  {
    const int Ticket = (int)MT4ORDERS::History[Index];
    const bool Res = (Ticket > 0) ? ::HistoryDealSelect(Ticket) : ((Ticket < 0) ? ::HistoryOrderSelect(-Ticket) : false);

    if (Res)
    {
      if (Ticket > 0)
        MT4ORDERS::GetHistoryPositionData(Ticket);
      else
        MT4ORDERS::GetHistoryOrderData(-Ticket);
    }

    return(Res);
  }

  //           
  static bool SelectByPos( const int Index )
  {
    const int Total = ::PositionsTotal();
    const bool Flag = (Index < Total);

    const bool Res = (Flag) ? ::PositionSelectByTicket(::PositionGetTicket(Index)) : ::OrderSelect(::OrderGetTicket(Index - Total));

    if (Res)
    {
      if (Flag)
        MT4ORDERS::GetPositionData();
      else
        MT4ORDERS::GetOrderData();
    }

    return(Res);
  }

  static bool SelectByHistoryTicket( const int Ticket )
  {
    bool Res = ::HistoryDealSelect(Ticket) ? MT4HISTORY::IsMT4Deal(Ticket) : false;

    if (Res)
      MT4ORDERS::GetHistoryPositionData(Ticket);
    else
    {
      Res = ::HistoryOrderSelect(Ticket) ? MT4HISTORY::IsMT4Order(Ticket) : false;

      if (Res)
        MT4ORDERS::GetHistoryOrderData(Ticket);
    }

    return(Res);
  }

  static bool SelectByExistingTicket( const int Ticket )
  {
    bool Res = true;

    if (::PositionSelectByTicket(Ticket))
      MT4ORDERS::GetPositionData();
    else if (::OrderSelect(Ticket))
      MT4ORDERS::GetOrderData();
    else
      Res = false;

    return(Res);
  }

  //        :
  // MODE_TRADES:    >   >  >  
  // MODE_HISTORY:  >   >   >  
  static bool SelectByTicket( const int Ticket, const int Pool = MODE_TRADES )
  {
    return((Pool == MODE_TRADES) ?
           (MT4ORDERS::SelectByExistingTicket(Ticket) ? true : MT4ORDERS::SelectByHistoryTicket(Ticket)) :
           (MT4ORDERS::SelectByHistoryTicket(Ticket) ? true : MT4ORDERS::SelectByExistingTicket(Ticket)));
  }

public:
  static uint OrderSend_MaxPause; //      .

  static bool MT4OrderSelect( const int Index, const int Select, const int Pool = MODE_TRADES )
  {
    return((Select == SELECT_BY_POS) ?
           ((Pool == MODE_TRADES) ? MT4ORDERS::SelectByPos(Index) : MT4ORDERS::SelectByPosHistory(Index)) :
           MT4ORDERS::SelectByTicket(Index, Pool));
  }

  //       MT5- OrderSelect
  static bool MT4OrderSelect( const ulong Ticket )
  {
    return(::OrderSelect(Ticket));
  }

  static int MT4OrdersTotal( void )
  {
    return(::OrdersTotal() + ::PositionsTotal());
  }

  //  ""     MT5- OrderSelect
  static int MT4OrdersTotal( const bool MT5 )
  {
    return(::OrdersTotal());
  }

  static int MT4OrdersHistoryTotal( void )
  {
    return(MT4ORDERS::History.GetAmount());
  }

  static int MT4OrderSend( const string Symb, const int Type, const double dVolume, const double Price, const int SlipPage, const double SL, const double TP,
                           const string comment = NULL, const int magic = 0, const datetime dExpiration = 0, color arrow_color = clrNONE )

  {
    MqlTradeRequest Request = {0};

    Request.action = (((Type == OP_BUY) || (Type == OP_SELL)) ? TRADE_ACTION_DEAL : TRADE_ACTION_PENDING);
    Request.magic = magic;

    Request.symbol = ((Symb == NULL) ? ::Symbol() : Symb);
    Request.volume = dVolume;
    Request.price = Price;

    Request.tp = TP;
    Request.sl = SL;
    Request.deviation = SlipPage;
    Request.type = (ENUM_ORDER_TYPE)Type;

    Request.type_filling = MT4ORDERS::GetFilling(Request.symbol, (uint)Request.deviation);

    if (dExpiration > 0)
    {
      Request.type_time = ORDER_TIME_SPECIFIED;
      Request.expiration = dExpiration;
    }

    Request.comment = comment;

    MqlTradeResult Result;

    return(MT4ORDERS::OrderSend(Request, Result) ?
           ((Request.action == TRADE_ACTION_DEAL) ? (::HistoryDealSelect(Result.deal) ? (int)::HistoryDealGetInteger(Result.deal, DEAL_POSITION_ID) : -1) : (int)Result.order) : -1);
  }

  static bool MT4OrderModify( const int Ticket, const double Price, const double SL, const double TP, const datetime Expiration, const color Arrow_Color = clrNONE )
  {
    MqlTradeRequest Request = {0};

               //  ,           
    bool Res = ((Ticket != MT4ORDERS::Order.Ticket) || (MT4ORDERS::Order.Ticket <= OP_SELL)) ?
               (MT4ORDERS::ModifyPosition(Ticket, Request) ? true : MT4ORDERS::ModifyOrder(Ticket, Price, Expiration, Request)) :
               (MT4ORDERS::ModifyOrder(Ticket, Price, Expiration, Request) ? true : MT4ORDERS::ModifyPosition(Ticket, Request));

    if (Res)
    {
      Request.tp = TP;
      Request.sl = SL;

      Res = MT4ORDERS::NewOrderSend(Request);
    }

    return(Res);
  }

  static bool MT4OrderClose( const int Ticket, const double dLots, const double Price, const int SlipPage, const color Arrow_Color = clrNONE )
  {
    bool Res = ::PositionSelectByTicket(Ticket);

    if (Res)
    {
      MqlTradeRequest Request = {0};

      Request.action = TRADE_ACTION_DEAL;
      Request.position = Ticket;

      Request.symbol = ::PositionGetString(POSITION_SYMBOL);

      Request.volume = dLots;
      Request.price = Price;

      //    SL/TP-   .  -  
//      Request.tp = ::PositionGetDouble(POSITION_SL);
//      Request.sl = ::PositionGetDouble(POSITION_TP);

      Request.deviation = SlipPage;

      Request.type = (ENUM_ORDER_TYPE)(1 - ::PositionGetInteger(POSITION_TYPE));

      Request.type_filling = MT4ORDERS::GetFilling(Request.symbol, (uint)Request.deviation);

      Res = MT4ORDERS::NewOrderSend(Request);
    }

    return(Res);
  }

  static bool MT4OrderDelete( const int Ticket, const color Arrow_Color = clrNONE )
  {
    bool Res = ::OrderSelect(Ticket);

    if (Res)
    {
      MqlTradeRequest Request = {0};

      Request.action = TRADE_ACTION_REMOVE;
      Request.order = Ticket;

      Res = MT4ORDERS::NewOrderSend(Request);
    }

    return(Res);
  }

#define MT4_ORDERFUNCTION(NAME,T)  \
  static T MT4Order##NAME( void )  \
  {                                \
    return(MT4ORDERS::Order.NAME); \
  }

  MT4_ORDERFUNCTION(Ticket, int)
  MT4_ORDERFUNCTION(Type, int)
  MT4_ORDERFUNCTION(Lots, double)
  MT4_ORDERFUNCTION(OpenPrice, double)
  MT4_ORDERFUNCTION(OpenTime, datetime)
  MT4_ORDERFUNCTION(StopLoss, double)
  MT4_ORDERFUNCTION(TakeProfit, double)
  MT4_ORDERFUNCTION(ClosePrice, double)
  MT4_ORDERFUNCTION(CloseTime, datetime)
  MT4_ORDERFUNCTION(Expiration, datetime)
  MT4_ORDERFUNCTION(MagicNumber, int)
  MT4_ORDERFUNCTION(Profit, double)
  MT4_ORDERFUNCTION(Commission, double)
  MT4_ORDERFUNCTION(Swap, double)
  MT4_ORDERFUNCTION(Symbol, string)
  MT4_ORDERFUNCTION(Comment, string)

#undef MT4_ORDERFUNCTION

  static void MT4OrderPrint( void )
  {
    Print(MT4ORDERS::Order.ToString());

    return;
  }
/*
  static string MT4OrderToString( void )
  {
    return(MT4ORDERS::Order.ToString());
  } */
};

// #define OrderToString MT4ORDERS::MT4OrderToString

static MT4_ORDER MT4ORDERS::Order = {0};

static MT4HISTORY MT4ORDERS::History;

static const bool MT4ORDERS::IsTester = (::MQLInfoInteger(MQL_TESTER) || ::MQLInfoInteger(MQL_OPTIMIZATION) ||
                                         ::MQLInfoInteger(MQL_VISUAL_MODE) || ::MQLInfoInteger(MQL_FRAME_MODE));

static uint MT4ORDERS::OrderSend_MaxPause = 1000000; //      .

bool OrderClose( const int Ticket, const double dLots, const double Price, const int SlipPage, const color Arrow_Color = clrNONE )
{
  return(MT4ORDERS::MT4OrderClose(Ticket, dLots, Price, SlipPage, Arrow_Color));
}

bool OrderModify( const int Ticket, const double Price, const double SL, const double TP, const datetime Expiration, const color Arrow_Color = clrNONE )
{
  return(MT4ORDERS::MT4OrderModify(Ticket, Price, SL, TP, Expiration, Arrow_Color));
}

bool OrderDelete( const int Ticket, const color Arrow_Color = clrNONE )
{
  return(MT4ORDERS::MT4OrderDelete(Ticket, Arrow_Color));
}

void OrderPrint( void )
{
  MT4ORDERS::MT4OrderPrint();

  return;
}

#define MT4_ORDERGLOBALFUNCTION(NAME,T)  \
  T Order##NAME( void )                  \
  {                                      \
    return(MT4ORDERS::MT4Order##NAME()); \
  }

MT4_ORDERGLOBALFUNCTION(sHistoryTotal, int)
MT4_ORDERGLOBALFUNCTION(Ticket, int)
MT4_ORDERGLOBALFUNCTION(Type, int)
MT4_ORDERGLOBALFUNCTION(Lots, double)
MT4_ORDERGLOBALFUNCTION(OpenPrice, double)
MT4_ORDERGLOBALFUNCTION(OpenTime, datetime)
MT4_ORDERGLOBALFUNCTION(StopLoss, double)
MT4_ORDERGLOBALFUNCTION(TakeProfit, double)
MT4_ORDERGLOBALFUNCTION(ClosePrice, double)
MT4_ORDERGLOBALFUNCTION(CloseTime, datetime)
MT4_ORDERGLOBALFUNCTION(Expiration, datetime)
MT4_ORDERGLOBALFUNCTION(MagicNumber, int)
MT4_ORDERGLOBALFUNCTION(Profit, double)
MT4_ORDERGLOBALFUNCTION(Commission, double)
MT4_ORDERGLOBALFUNCTION(Swap, double)
MT4_ORDERGLOBALFUNCTION(Symbol, string)
MT4_ORDERGLOBALFUNCTION(Comment, string)

#undef MT4_ORDERGLOBALFUNCTION

//   
#define OrdersTotal MT4ORDERS::MT4OrdersTotal //  Expert/Expert.mqh -   MT5-OrdersTotal()

bool OrderSelect( const int Index, const int Select, const int Pool = MODE_TRADES )
{
  return(MT4ORDERS::MT4OrderSelect(Index, Select, Pool));
}

int OrderSend( const string Symb, const int Type, const double dVolume, const double Price, const int SlipPage, const double SL, const double TP,
               const string comment = NULL, const int magic = 0, const datetime dExpiration = 0, color arrow_color = clrNONE )
{
  return(MT4ORDERS::MT4OrderSend(Symb, Type, dVolume, Price, SlipPage, SL, TP, comment, magic, dExpiration, arrow_color));
}

#endif // __MT4ORDERS__
#endif // __MQL5__